using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace WindowsApplication8
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private GridRangeInfoList wholeSelectedRows = new GridRangeInfoList();
        private GridRangeInfoList cannotSelectCells = new GridRangeInfoList();
        private void Form1_Load(object sender, EventArgs e)
        {
            this.gridControl1.AllowSelection = GridSelectionFlags.Any;// &~GridSelectionFlags.Shift;// &~GridSelectionFlags.Keyboard;

            this.gridControl1.ExcelLikeCurrentCell = true; //so cuurentcell is part of selection

           
           
            this.gridControl1.SelectionChanging += new GridSelectionChangingEventHandler(gridControl1_SelectionChanging);

            this.gridControl1.CurrentCellMoved += new GridCurrentCellMovedEventHandler(gridControl1_CurrentCellMoved);
            this.gridControl1.MouseMove += new MouseEventHandler(gridControl1_MouseMove);

            //require an entire row - row 3 & 7 must be selected as entire row
            wholeSelectedRows.Add(GridRangeInfo.Row(3));
            wholeSelectedRows.Add(GridRangeInfo.Row(7));
            //color them so you can see them
            gridControl1.RowStyles[3].BackColor = Color.LightYellow;
            gridControl1.RowStyles[7].BackColor = Color.LightYellow;

            cannotSelectCells.Add(GridRangeInfo.Cell(2, 2));
            cannotSelectCells.Add(GridRangeInfo.Cell(2, 4));
            cannotSelectCells.Add(GridRangeInfo.Cell(5, 3));
            //color them so you can see them
            gridControl1[2, 2].BackColor = Color.LightPink;
            gridControl1[2, 4].BackColor = Color.LightPink;
            gridControl1[5, 3].BackColor = Color.LightPink;

            //cells that cannot get focus
            gridControl1[8, 3].Enabled = false;
            gridControl1[9, 4].Enabled = false;
            //also make them so they cannot be drag-selected
            cannotSelectCells.Add(GridRangeInfo.Cell(8, 3));
            cannotSelectCells.Add(GridRangeInfo.Cell(9, 4));
            //color them so you can see them
            gridControl1[8, 3].BackColor = Color.LightGray;
            gridControl1[9, 4].BackColor = Color.LightGray;

        }

        void gridControl1_MouseMove(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                int row, col;
                if (gridControl1.PointToRowCol(e.Location, out row, out col))
                {
                    this.gridControl1.Selections.SelectRange(GridRangeInfo.Cell(row, col), true);
                }
            }
        }

        void gridControl1_CurrentCellMoved(object sender, GridCurrentCellMovedEventArgs e)
        {
            this.gridControl1.Selections.SelectRange(gridControl1.CurrentCell.RangeInfo, true);
        }

        
        

        void gridControl1_SelectionChanging(object sender, GridSelectionChangingEventArgs e)
        {
           // Console.WriteLine(e.Reason);
           

            if (e.Range != null && !e.Range.IsEmpty)
            {
                if (e.Reason != GridSelectionReason.SelectRange && e.Reason != GridSelectionReason.ArrowKey)
                {
                    e.Cancel = true;
                    return;
                }
                foreach (GridRangeInfo range in cannotSelectCells)
                {
                    if (e.Range.IntersectsWith(range))
                    {
                        e.Cancel = true; //do not allow selection
                    }
                }


                foreach (GridRangeInfo range in wholeSelectedRows)
                {
                    if (e.Range.IntersectsWith(range) && !e.Range.Contains(range))
                    {
                        gridControl1.Selections.SelectRange(range, true); //extend selection to whole row
                        gridControl1.Refresh();
                        e.Cancel = true;

                    }
                }
            }
        
        }
    }
}